﻿using System;
using Composite.Data;
using Composite.Data.Hierarchy;
using Composite.Data.Hierarchy.DataAncestorProviders;


namespace Composite.WritableDataProvider
{
    /// <summary>
    /// The VCard C1 data interface
    /// </summary>
    [AutoUpdateble]
    [ImmutableTypeId("{ECAC8ECD-3849-4AA4-983F-AFE448AA4EE1}")]
    [KeyPropertyName("Id")]
    [DataAncestorProvider(typeof(NoAncestorDataAncestorProvider))]
    [DataScope(DataScopeIdentifier.PublicName)]
    [LabelPropertyName("Name")]
    [CachingAttribute(CachingType.Full)]
    public interface IVCard : IData
    {
        [StoreFieldType(PhysicalStoreFieldType.Guid)]        
        [ImmutableFieldId("{CDE7FE14-3F4E-4738-AFFC-7F5E21640A54}")]
        Guid Id { get; set; }


        [DefaultFieldStringValue("")]
        [StoreFieldType(PhysicalStoreFieldType.String, 256)]
        [ImmutableFieldId("{A0FA4FD1-0952-44FD-A17B-42C3249FDC46}")]
        string Name { get; set; } // N


        [DefaultFieldStringValue("")]
        [StoreFieldType(PhysicalStoreFieldType.String, 256)]
        [ImmutableFieldId("{A9FAB914-EFD0-4DC6-85CB-1029CBFCDC78}")]
        string FormattedName { get; set; } // FN


        [DefaultFieldStringValue("")]
        [StoreFieldType(PhysicalStoreFieldType.String, 256)]
        [ImmutableFieldId("{23F4CE24-2A68-4CD8-96E0-3FD124B85243}")]
        string Title { get; set; } // TITLE


        [DefaultFieldStringValue("")]
        [StoreFieldType(PhysicalStoreFieldType.String, 256)]
        [ImmutableFieldId("{33E7147B-6084-44F5-9424-C09E309ECD90}")]
        string EMail { get; set; } // EMAIL
    }
}
